"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.flag = void 0;
const symbols_1 = require("./symbols");
const utils_1 = require("./utils");
function flag(name, value, fn) {
    return (inner) => {
        const innerGuard = (0, utils_1.enyToGuard)(inner);
        const flagsMap = new Map(innerGuard[symbols_1._flags]);
        flagsMap.set(name, value);
        const getGuardFnFromOptions = (o) => (val, context, path, parent) => fn(inner)(val, o, context, path, parent);
        const validate = ((options) => ({
            [symbols_1._name]: innerGuard[symbols_1._name],
            [symbols_1._guard]: (val, context, path, parent) => {
                if (typeof options === "function")
                    options = options(parent, context);
                return getGuardFnFromOptions(options)(val, context, path, parent);
            },
            [symbols_1._type]: innerGuard[symbols_1._type],
            [symbols_1._flags]: flagsMap,
        }));
        validate[symbols_1._name] = innerGuard[symbols_1._name];
        validate[symbols_1._guard] = getGuardFnFromOptions({});
        validate[symbols_1._type] = innerGuard[symbols_1._type];
        validate[symbols_1._flags] = flagsMap;
        return validate;
    };
}
exports.flag = flag;
//# sourceMappingURL=flag.js.map