"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.extendScalar = exports.scalar = void 0;
const symbols_1 = require("./symbols");
const types_1 = require("./types");
const typeUtils_1 = require("./typeUtils");
const valit_1 = require("./valit");
function scalar(...[name, scalarFn, handleOptions, defaultOptions]) {
    return (0, valit_1.makeValit)(name, (fn) => (value, options, context, path, parent) => {
        const res = fn(value, options, context, path, parent);
        if (res !== undefined) {
            return {
                valid: true,
                data: res,
                errors: [],
            };
        }
        return {
            valid: false,
            data: undefined,
            errors: [
                {
                    message: `vality.${name}.base`,
                    path,
                    options,
                    value,
                },
            ],
        };
    }, handleOptions, defaultOptions)(scalarFn);
}
exports.scalar = scalar;
function extendScalar(base) {
    return function extendedScalar(...[name, scalarFn, handleOptions, defaultOptions]) {
        types_1.types.set(name, (0, typeUtils_1.getName)(base));
        return scalar(name, (val, options, context, path, parent) => {
            const res = base[symbols_1._guard](val, context, path, parent);
            if (!res.valid)
                return undefined;
            return scalarFn(res.data, options, context, path, parent);
        }, handleOptions, defaultOptions);
    };
}
exports.extendScalar = extendScalar;
//# sourceMappingURL=scalar.js.map