"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getFlags = exports.enyToGuardFn = exports.enyToGuard = void 0;
const symbols_1 = require("./symbols");
const vality_1 = require("./vality");
function enyToGuard(eny) {
    if (isGuard(eny))
        return eny;
    if (typeof eny === "string" ||
        typeof eny === "number" ||
        typeof eny === "boolean" ||
        eny === null) {
        return vality_1.vality.literal(eny);
    }
    if (Array.isArray(eny)) {
        if (eny.length === 0)
            throw new Error("Empty array Short");
        if (eny.length === 1)
            return vality_1.vality.array(enyToGuard(eny[0]));
        return vality_1.vality.enum(...eny.map(enyToGuard));
    }
    return vality_1.vality.object(eny);
}
exports.enyToGuard = enyToGuard;
function isGuard(val) {
    return ((typeof val === "object" || typeof val === "function") &&
        val !== null &&
        symbols_1._guard in val);
}
function enyToGuardFn(e) {
    return enyToGuard(e)[symbols_1._guard];
}
exports.enyToGuardFn = enyToGuardFn;
const emptyMap = new Map();
function getFlags(e) {
    var _a;
    if (!isGuard(e))
        return emptyMap;
    return (_a = e[symbols_1._flags]) !== null && _a !== void 0 ? _a : emptyMap;
}
exports.getFlags = getFlags;
//# sourceMappingURL=utils.js.map