"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.validate = exports.mergeOptions = void 0;
const config_1 = require("./config");
const utils_1 = require("./utils");
const defaults = {
    allowExtraProperties: true,
    strict: false,
    bail: false,
};
function mergeOptions(options, context, fields) {
    var _a, _b, _c;
    const result = {};
    for (const field of fields) {
        result[field] =
            (_c = (_b = (_a = options[field]) !== null && _a !== void 0 ? _a : context[field]) !== null && _b !== void 0 ? _b : config_1.config[field]) !== null && _c !== void 0 ? _c : defaults[field];
    }
    return result;
}
exports.mergeOptions = mergeOptions;
function validate(schema, val, context) {
    return (0, utils_1.enyToGuardFn)(schema)(val, context !== null && context !== void 0 ? context : {}, [], undefined);
}
exports.validate = validate;
//# sourceMappingURL=validate.js.map