"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.makeValit = void 0;
const symbols_1 = require("./symbols");
function makeValit(...[name, fn, handleOptions, defaultOptions]) {
    return (...args) => {
        const getGuardFnFromOptions = (options) => (value, context, path, parent) => {
            var _a;
            const { transform, preprocess, default: defaultValue, validate, bail } = options, optionsWithoutExtras = __rest(options, ["transform", "preprocess", "default", "validate", "bail"]);
            const optionsWithDefault = Object.assign(Object.assign({}, defaultOptions), optionsWithoutExtras);
            if (typeof preprocess === "function") {
                value = preprocess(value, options, context, path, parent);
            }
            const data = fn(...args)(value, options, context, path, parent);
            if (!data.valid) {
                if (value === undefined && defaultValue !== undefined) {
                    return { valid: true, data: defaultValue, errors: [] };
                }
                return data;
            }
            if (typeof validate === "function" && validate(data.data, options, context, path, parent) === false) {
                return {
                    valid: false,
                    data: undefined,
                    errors: [
                        {
                            message: `vality.${name}.custom`,
                            path,
                            options,
                            value,
                        },
                    ],
                };
            }
            const origData = data.data;
            if (typeof transform === "function") {
                data.data = transform(data.data);
            }
            if (handleOptions === undefined)
                return data;
            const keysWithError = [];
            for (const key in optionsWithDefault) {
                if (((_a = handleOptions[key]) === null || _a === void 0 ? void 0 : _a.call(handleOptions, origData, optionsWithDefault[key], options, context)) === false) {
                    keysWithError.push(key);
                    if (bail)
                        break;
                }
            }
            if (keysWithError.length === 0)
                return data;
            return {
                valid: false,
                data: undefined,
                errors: keysWithError.map((k) => ({
                    message: k in options
                        ? `vality.${name}.options.${k}`
                        : `vality.${name}.base`,
                    options,
                    path,
                    value,
                })),
            };
        };
        const flagsMap = new Map();
        const validate = (options => ({
            [symbols_1._name]: name,
            [symbols_1._guard]: (val, context, path, parent) => {
                if (typeof options === "function")
                    options = options(parent, context);
                return getGuardFnFromOptions(options)(val, context, path, parent);
            },
            [symbols_1._type]: args,
            [symbols_1._flags]: flagsMap,
        }));
        validate[symbols_1._name] = name;
        validate[symbols_1._guard] = getGuardFnFromOptions({});
        validate[symbols_1._type] = args;
        validate[symbols_1._flags] = flagsMap;
        return validate;
    };
}
exports.makeValit = makeValit;
//# sourceMappingURL=valit.js.map