import { _flags, _guard, _name, _type } from "./symbols";
import { enyToGuard } from "./utils";
export function flag(name, value, fn) {
    return (inner) => {
        const innerGuard = enyToGuard(inner);
        const flagsMap = new Map(innerGuard[_flags]);
        flagsMap.set(name, value);
        const getGuardFnFromOptions = (o) => (val, context, path, parent) => fn(inner)(val, o, context, path, parent);
        const validate = ((options) => ({
            [_name]: innerGuard[_name],
            [_guard]: (val, context, path, parent) => {
                if (typeof options === "function")
                    options = options(parent, context);
                return getGuardFnFromOptions(options)(val, context, path, parent);
            },
            [_type]: innerGuard[_type],
            [_flags]: flagsMap,
        }));
        validate[_name] = innerGuard[_name];
        validate[_guard] = getGuardFnFromOptions({});
        validate[_type] = innerGuard[_type];
        validate[_flags] = flagsMap;
        return validate;
    };
}
//# sourceMappingURL=flag.js.map