import { flag } from "./flag";
import { enyToGuardFn } from "./utils";
import { mergeOptions } from "./validate";
import { vality } from "./vality";
vality.from = (key) => flag("from", key, (e) => (val, _options, context, path, parent) => enyToGuardFn(e)(val, context, path, parent));
vality.optional = flag("optional", true, (e) => (val, options, context, path, parent) => {
    const enyVal = enyToGuardFn(e)(val, context, path, parent);
    if (enyVal.valid)
        return enyVal;
    if (val === undefined)
        return { valid: true, data: undefined, errors: [] };
    const { strict } = mergeOptions(options, context, ["strict"]);
    if (!strict && val === null)
        return { valid: true, data: undefined, errors: [] };
    return enyVal;
});
vality.virtual = flag("virtual", true, (e) => (val, _options, _context, path) => {
    if (val === undefined)
        return {
            valid: true,
            data: undefined,
            errors: [],
        };
    return {
        valid: false,
        data: undefined,
        errors: [
            {
                message: "vality.virtual.base",
                path,
                options: {},
                value: val,
            },
        ],
    };
});
//# sourceMappingURL=flags.js.map