import { _guard } from "./symbols";
import { types } from "./types";
import { getName } from "./typeUtils";
import { makeValit } from "./valit";
export function scalar(...[name, scalarFn, handleOptions, defaultOptions]) {
    return makeValit(name, (fn) => (value, options, context, path, parent) => {
        const res = fn(value, options, context, path, parent);
        if (res !== undefined) {
            return {
                valid: true,
                data: res,
                errors: [],
            };
        }
        return {
            valid: false,
            data: undefined,
            errors: [
                {
                    message: `vality.${name}.base`,
                    path,
                    options,
                    value,
                },
            ],
        };
    }, handleOptions, defaultOptions)(scalarFn);
}
export function extendScalar(base) {
    return function extendedScalar(...[name, scalarFn, handleOptions, defaultOptions]) {
        types.set(name, getName(base));
        return scalar(name, (val, options, context, path, parent) => {
            const res = base[_guard](val, context, path, parent);
            if (!res.valid)
                return undefined;
            return scalarFn(res.data, options, context, path, parent);
        }, handleOptions, defaultOptions);
    };
}
//# sourceMappingURL=scalar.js.map