import { _flags, _guard } from "./symbols";
import { vality } from "./vality";
export function enyToGuard(eny) {
    if (isGuard(eny))
        return eny;
    if (typeof eny === "string" ||
        typeof eny === "number" ||
        typeof eny === "boolean" ||
        eny === null) {
        return vality.literal(eny);
    }
    if (Array.isArray(eny)) {
        if (eny.length === 0)
            throw new Error("Empty array Short");
        if (eny.length === 1)
            return vality.array(enyToGuard(eny[0]));
        return vality.enum(...eny.map(enyToGuard));
    }
    return vality.object(eny);
}
function isGuard(val) {
    return ((typeof val === "object" || typeof val === "function") &&
        val !== null &&
        _guard in val);
}
export function enyToGuardFn(e) {
    return enyToGuard(e)[_guard];
}
const emptyMap = new Map();
export function getFlags(e) {
    if (!isGuard(e))
        return emptyMap;
    return e[_flags] ?? emptyMap;
}
//# sourceMappingURL=utils.js.map