import { config } from "./config";
import { enyToGuardFn } from "./utils";
const defaults = {
    allowExtraProperties: true,
    strict: false,
    bail: false,
};
export function mergeOptions(options, context, fields) {
    const result = {};
    for (const field of fields) {
        result[field] =
            options[field] ?? context[field] ?? config[field] ?? defaults[field];
    }
    return result;
}
export function validate(schema, val, context) {
    return enyToGuardFn(schema)(val, context ?? {}, [], undefined);
}
//# sourceMappingURL=validate.js.map