import { Compound } from "./compound";
import { Parse } from "./parse";
import { Eny, OneOrEnumOfTOrGuard, RSE } from "./utils";
declare global {
    namespace vality {
        interface compounds {
            array: <E extends Eny>(e: E) => Compound<"array", E[], {
                minLength: number;
                maxLength: number;
            }>;
            tuple: <E extends Eny[]>(...es: E) => Compound<"tuple", E>;
            object: <O extends RSE>(o: O) => Compound<"object", O, {
                allowExtraProperties: boolean;
            }>;
            dict: <K extends OneOrEnumOfTOrGuard<string | number>, V extends Eny>(k: K, v: V) => Compound<"dict", [
                typeof k,
                typeof v
            ], {
                allowExtraProperties: boolean;
            }>;
            enum: <E extends Eny[]>(...es: E) => Compound<"enum", E[number]>;
            and: <E extends OneOrEnumOfTOrGuard<RSE | RSE[]>[]>(...es: E) => Compound<"and", typeof es, {
                transform: (val: Parse<Compound<"and", E>>) => Parse<Compound<"and", E>>;
            }>;
        }
    }
}
//# sourceMappingURL=compounds.d.ts.map