import { Scalar } from "./scalar";
import { Primitive } from "./utils";
declare global {
    namespace vality {
        interface scalars {
            string: Scalar<"string", string, {
                minLength: number;
                maxLength: number;
                match: RegExp;
            }>;
            number: Scalar<"number", number, {
                min: number;
                max: number;
                onlyInteger: boolean;
                allowUnsafe: boolean;
                allowNaN: boolean;
            }>;
            boolean: Scalar<"boolean", boolean>;
            date: Scalar<"date", Date, {
                min: Date;
                max: Date;
                past: boolean;
                future: boolean;
            }>;
            any: Scalar<"any", unknown>;
            never: Scalar<"never", never>;
            literal<P extends Primitive>(lit: P): Scalar<"literal", P, {
                default: boolean;
            }>;
        }
    }
}
//# sourceMappingURL=scalars.d.ts.map