import { Parse } from "./parse";
import { Eny, RSA } from "./utils";
export interface Error {
    message: string;
    path: Path;
    options: unknown;
    value: unknown;
}
export declare type ValidationResult<T> = {
    valid: true;
    data: T;
    errors: readonly never[];
} | {
    valid: false;
    data: undefined;
    errors: readonly Error[];
};
export declare type Path = (string | number)[];
export interface Context {
    allowExtraProperties?: boolean;
    strict?: boolean;
    bail?: boolean;
}
export declare function mergeOptions<Options extends RSA, Fields extends keyof Options>(options: Options, context: Partial<RSA>, fields: Fields[]): Required<Pick<Options, Fields>>;
export declare function validate<E extends Eny>(schema: E, val: unknown, context?: RSA): ValidationResult<Parse<E>>;
//# sourceMappingURL=validate.d.ts.map