import { CompoundFn } from "./compound";
import { _flags, _guard, _name, _type } from "./symbols";
import { RSA } from "./utils";
import { Context, Path, ValidationResult } from "./validate";
export interface SpecialOptions<T, O> {
    strict: boolean;
    bail: boolean;
    preprocess: (val: unknown, options: Partial<CallOptions<T, O>>, context: Context, path: Path, parent?: any) => unknown;
    default: T;
    validate: (val: T, options: Partial<CallOptions<T, O>>, context: Context, path: Path, parent?: any) => boolean;
    transform: (val: T) => T;
}
export declare type ValitParameters<Name, Type, Options extends RSA, Fn> = [
    name: Name,
    fn: Fn,
    handleOptions?: {
        [K in string & keyof Options]?: (val: Type, o: NonNullable<Options[K]>, options: CallOptions<Type, Options> & Pick<Options, K>, context: Context) => boolean;
    },
    defaultOptions?: Partial<Options>
];
export declare type Valit<Name, Type, Options, IsCompound> = ((options: CallOptions<Type, Options> | ((parent: any, context: Context) => CallOptions<Type, Options>)) => Guard<Name, Type, IsCompound>) & Guard<Name, Type, IsCompound>;
export interface Guard<Name, Type, IsCompound> {
    [_name]: Name;
    [_guard]: GuardFn<Type>;
    [_type]: Type;
    [_flags]: Map<string, unknown>;
    isCompound?: IsCompound;
}
export interface GuardFn<T> {
    (val: unknown, context: Context, path: Path, parent: any): ValidationResult<T>;
}
export declare type CallOptions<Type, Options> = [Options] extends [never] ? Partial<SpecialOptions<Type, Options>> : Partial<Options & Omit<SpecialOptions<Type, Options>, keyof Options>>;
export declare type FnArgs<Type, Options, ValueType = unknown> = [
    value: ValueType,
    options: Partial<CallOptions<Type, Options>>,
    context: Context,
    path: Path,
    parent?: any
];
export declare function makeValit<Name extends string, Arg extends any[], Type, Options extends RSA, IsValit extends boolean>(...[name, fn, handleOptions, defaultOptions]: ValitParameters<Name, Type, Options, (...args: Arg) => CompoundFn<Type, Options>>): (...args: Arg) => Valit<Name, Type, Options, IsValit>;
//# sourceMappingURL=valit.d.ts.map